package com.company;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.Random;

public class Main {

    public static void main(String[] args) {
        ArrayList<Card> cards = new ArrayList<>();
        String Color;
        String Color1;
        for (int i = 1; i < 5; i++) {
            switch (i) {
                case 1:
                    Color = "Red";
                    break;
                case 2:
                    Color = "Yellow";
                    break;
                case 3:
                    Color = "Green";
                    break;
                case 4:
                    Color = "Blue";
                    break;
                default:
                    throw new IllegalStateException("Unexpected value: " + i);
            }
            for (int j = 0; j < 10; j++) {
                Numeric numeric = new Numeric(Color, 0, j);
                cards.add(numeric);
            }
            Skip skip = new Skip(Color, 1, 0);
            cards.add(skip);
            Reverse reverse = new Reverse(Color, 1, 1);
            cards.add(reverse);
            Draw draw = new Draw(Color, 1, 2);
            cards.add(draw);
            Black black = new Black("Black", 0);
            cards.add(black);
        }
        for (int i = 1; i < 5; i++) {
            switch (i) {
                case 1:
                    Color1 = "Red";
                    break;
                case 2:
                    Color1 = "Yellow";
                    break;
                case 3:
                    Color1 = "Green";
                    break;
                case 4:
                    Color1 = "Blue";
                    break;
                default:
                    throw new IllegalStateException("Unexpected value: " + i);
            }
            for (int j = 1; j < 10; j++) {
                Numeric numeric = new Numeric(Color1, 0, j);
                cards.add(numeric);
            }
            Skip skip = new Skip(Color1, 1, 0);
            cards.add(skip);
            Reverse reverse = new Reverse(Color1, 1, 1);
            cards.add(reverse);
            Draw draw = new Draw(Color1, 1, 2);
            cards.add(draw);
            WildDraw wildDraw = new WildDraw("Black", 1);
            cards.add(wildDraw);
        }
        //System.out.println(cards.size());
        /*for (int i = 0; i < 108; i++){
            System.out.println(cards.get(i).toString());
        }*/
        Random r = new Random();
        int nextCardNumber;
        ArrayList<Player> players = new ArrayList<>();
        Comp comp1 = new Comp(); players.add(comp1);
        Comp comp2 = new Comp(); players.add(comp2);
        Human human1 = new Human(); players.add(human1);
        Comp comp3 = new Comp(); players.add(comp3);
        for (int i = 0; i < 4; i++) {
            for (int j = 1; j < 8; j++) {
                nextCardNumber = r.nextInt(cards.size());
                players.get(i).getPlayerCards().add(cards.get(nextCardNumber));
                cards.remove(nextCardNumber);
                //System.out.println("cardNumber = " + next);
            }
            //p.printAllCards(i);
        }

        for (int i = 0; i < 4; i++) {
            players.get(i).printAllCards(i + 1);
            System.out.println(players.get(i).getPlayerPoint());
            System.out.println();
        }
        // first random card from the storage of cards (most be a colored card)
        nextCardNumber = r.nextInt(cards.size());
        if (cards.get(nextCardNumber) instanceof Black) {
            while (cards.get(nextCardNumber) instanceof Black) {
                nextCardNumber = r.nextInt(cards.size());
            }
        }
        Card nextCard = cards.get(nextCardNumber);
        System.out.println(nextCard.toString());
        System.out.println();
        cards.remove(nextCardNumber);
        int nextPlayerNumber = r.nextInt(4);
        System.out.println("Player" + (nextPlayerNumber + 1) + " starts the game");
        int move = 1;
        Player p = null;
        int turns = nextPlayerNumber; int c = 0; String nextColor = null; Card card = null;
        // starts a round
        while (c < 9) {
            turns %= 4;
            c++;
            Iterator<Player> playerIterator = players.iterator();
            while (playerIterator.hasNext()) {
                p = playerIterator.next();
                if (p.getPlayerCards().size() == 0)
                    break;
            }
            if (p.getPlayerCards().size() == 0)
                break;
            if (move == 1)
                System.out.println("Clockwise");
            else
                System.out.println("CounterClockwise");
            if (nextColor == null)
             players.get(turns).checkAllCards(nextCard);
            else
             players.get(turns).checkColors(nextColor);
            players.get(turns).printAllPossibleCards(turns + 1);
            System.out.println();
            players.get(turns).printAllCards(turns + 1);
            System.out.println();
            if (nextCard != null)
                card = players.get(turns).chooseCardToThrow(cards, nextCard);
            else
                card = players.get(turns).chooseColorToThrow(cards, nextColor);
            if (card != null) {
                System.out.println(card.toString());
                nextColor = players.get(turns).chooseColorIfBlack(card);
                if (nextColor == null)
                    nextCard = card;
            }
            if (nextCard != null)
                System.out.println(nextCard.toString());
            else
                System.out.println(nextColor);
            turns += move;
        }
        // sort players by each player's point (Ascending sort)
        /*Iterator<Player> players1 = players.iterator(); int min = 350;
        while (players1.hasNext()){
            p = players1.next();
            if (p.getPlayerPoint() < min)
                min = p.getPlayerPoint();
        }*/
        // end the round by showing each player's point
        /*Iterator<Player> players2 = players.iterator(); int c = 0;
        while (players2.hasNext()){
            c++;
            System.out.println(players2.next().toString(c));
        }*/

        // unicode of black color:  "\033[0;30m"
        // unicode of red color:  "\033[0;31m"
        // unicode of green color:  "\033[0;32m"
        // unicode of yellow color:  "\033[0;33m"
        // unicode of blue color:  "\033[0;34m"
        // unicode of forbidden: "\u29B8"
        /*for (int i = 1; i < 4; i++){
            System.out.print("\033[0;31m" + "|");
            if ((i == 1) || (i == 3)){
                for (int j = 1; j < 6; j++)
                    System.out.print("$");
            }
            else{
                    System.out.print("  ");
                int s;
                if (i == 2) {
                    s = 0;
                    System.out.print("0");
                }
                else
                  s = 1;
                for (int j = 1; j < 3 + s; j++)
                    System.out.print(" ");
            }
            System.out.println("|");
        }*/
    }
}
