package com.company;

public class Numeric extends Colored {
    private int number;
    public Numeric(String color, int colorType, int number) {
        super(color, colorType);
        this.number = number;
    }

    @Override
    public String toString() {
        return "Numeric{ Color=" + cardColor +
                ", number=" + number + '}';
    }

    @Override
    public boolean checkEquality(Colored coloredToCompare) {
        if (super.checkEquality(coloredToCompare))
            return true;
        if (!super.checkEquality(coloredToCompare) && coloredToCompare instanceof Numeric
                && ((Numeric) coloredToCompare).number == number)
            return true;
        return false;
    }

    @Override
    public int getCardPoint() {
        return number;
    }
}
